clear all;
clc;
load mushroom_cellnewbal.mat;
mushroom_num = E;

% get size of dataset
[mushroom_row,mushroom_column] = size(mushroom_num);

% 4 way cross validation
mushroom1 = mushroom_num(1:mushroom_row/4,:);
mushroom2 = mushroom_num(mushroom_row/4 + 1:2*mushroom_row/4,:);
mushroom3 = mushroom_num(2*mushroom_row/4 + 1:3*mushroom_row/4,:);
mushroom4 = mushroom_num(3*mushroom_row/4 + 1:mushroom_row,:);

% 4 pairs of training sample and testing sample
mushroom_train1 = [mushroom1;mushroom2;mushroom3];
mushroom_test1 = mushroom4;
mushroom_train2 = [mushroom1;mushroom2;mushroom4];
mushroom_test2 = mushroom3;
mushroom_train3 = [mushroom1;mushroom3;mushroom4];
mushroom_test3 = mushroom2;
mushroom_train4 = [mushroom2;mushroom3;mushroom4];
mushroom_test4 = mushroom1;

% size in loop
trainsize = 3*mushroom_row/4;
testsize = mushroom_row/4;

% initialize 4 distance matrices and 4 sorted distance matrices
distance1 = zeros(testsize,trainsize);
distance2 = zeros(testsize,trainsize);
distance3 = zeros(testsize,trainsize);
distance4 = zeros(testsize,trainsize);
dis1 = zeros(testsize,trainsize);
dis2 = zeros(testsize,trainsize);
dis3 = zeros(testsize,trainsize);
dis4 = zeros(testsize,trainsize);

% initialize 4 index matrices
IX1 = zeros(testsize,trainsize);
IX2 = zeros(testsize,trainsize);
IX3 = zeros(testsize,trainsize);
IX4 = zeros(testsize,trainsize);

% initialize 4 matrices to store edibility
ED1 = zeros(testsize,trainsize);
ED2 = zeros(testsize,trainsize);
ED3 = zeros(testsize,trainsize);
ED4 = zeros(testsize,trainsize);

% initialize 4 matrices to store final edibility
FED1 = zeros(testsize,1);
FED2 = zeros(testsize,1);
FED3 = zeros(testsize,1);
FED4 = zeros(testsize,1);

% initialize 4 matrices of right test
rt1 = zeros(mushroom_column - 1,1);
rt2 = zeros(mushroom_column - 1,1);
rt3 = zeros(mushroom_column - 1,1);
rt4 = zeros(mushroom_column - 1,1);

% initialize 4 matrices of rate
cr1 = zeros(mushroom_column - 1,1);
cr2 = zeros(mushroom_column - 1,1);
cr3 = zeros(mushroom_column - 1,1);
cr4 = zeros(mushroom_column - 1,1);

% calculate distances by Euclidean
for i = 1:testsize
    for j = 1:trainsize
        distance1(i,j) = eucdis(mushroom_train1(j,1:mushroom_column-1),mushroom_test1(i,1:mushroom_column-1));
    end
end

for i = 1:testsize
    for j = 1:trainsize
        distance2(i,j) = eucdis(mushroom_train2(j,1:mushroom_column-1),mushroom_test2(i,1:mushroom_column-1));
    end
end

for i = 1:testsize
    for j = 1:trainsize
        distance3(i,j) = eucdis(mushroom_train3(j,1:mushroom_column-1),mushroom_test3(i,1:mushroom_column-1));
    end
end

for i = 1:testsize
    for j = 1:trainsize
        distance4(i,j) = eucdis(mushroom_train4(j,1:mushroom_column-1),mushroom_test4(i,1:mushroom_column-1));
    end
end

% sort distances and get corresponding index
for i = 1:testsize
    [dis1(i,:),IX1(i,:)] = sort(distance1(i,:));
end

for i = 1:testsize
    [dis2(i,:),IX2(i,:)] = sort(distance2(i,:));
end

for i = 1:testsize
    [dis3(i,:),IX3(i,:)] = sort(distance3(i,:));
end

for i = 1:testsize
    [dis4(i,:),IX4(i,:)] = sort(distance4(i,:));
end

% get corresponding edibility
for i = 1:testsize
    for j = 1:trainsize
        ED1(i,j) = mushroom_train1(IX1(i,j),mushroom_column);
    end
end

for i = 1:testsize
    for j = 1:trainsize
        ED2(i,j) = mushroom_train2(IX2(i,j),mushroom_column);
    end
end

for i = 1:testsize
    for j = 1:trainsize
        ED3(i,j) = mushroom_train3(IX3(i,j),mushroom_column);
    end
end

for i = 1:testsize
    for j = 1:trainsize
        ED4(i,j) = mushroom_train4(IX4(i,j),mushroom_column);
    end
end
                
% determine edible or poisonous by possibility
for j = 1:mushroom_column - 1
    for i = 1:testsize
        if mean(ED1(i,1:j)) >= 0.5
           FED1(i) = 1;
        else
           FED1(i) = 0;
        end
    end

    for i = 1:testsize
        if mean(ED2(i,1:j)) >= 0.5
           FED2(i) = 1;
        else
           FED2(i) = 0;
        end
    end

    for i = 1:testsize
        if mean(ED3(i,1:j)) >= 0.5
           FED3(i) = 1;
        else
           FED3(i) = 0;
        end
    end

    for i = 1:testsize
        if mean(ED4(i,1:j)) >= 0.5
           FED4(i) = 1;
        else
           FED4(i) = 0;
        end
    end
    
% calculate classification rate
    for i = 1:testsize
        if FED1(i) == mushroom_test1(i,mushroom_column)
           rt1(j) = rt1(j) + 1;
        end
    end

    for i = 1:testsize
        if FED2(i) == mushroom_test2(i,mushroom_column)
           rt2(j) = rt2(j) + 1;
        end
    end

    for i = 1:testsize
        if FED3(i) == mushroom_test3(i,mushroom_column)
           rt3(j) = rt3(j) + 1;
        end
    end

    for i = 1:testsize
        if FED4(i) == mushroom_test4(i,mushroom_column)
           rt4(j) = rt4(j) + 1;
        end
    end

    cr1(j) = rt1(j)/testsize;
    cr2(j) = rt2(j)/testsize;
    cr3(j) = rt3(j)/testsize;
    cr4(j) = rt4(j)/testsize;
    
end

    

    

        



